var JSONStream, jsonRequest, request, zlib;

request = require('request');

JSONStream = require('JSONStream');

zlib = require('zlib');

var throttledRequest = require('throttled-request')(request);

throttledRequest.configure({
  requests: 10,
  milliseconds: 2000
});

jsonRequest = function(jsonSelector, options) {
  var outStream;
  outStream = JSONStream.parse(jsonSelector);
  options.gzip = true;
  throttledRequest(options).on('response', function(response) {
    var encoding, gunzip, ref;
    if (response.statusCode === 200) {
      encoding = (ref = response.headers['content-encoding']) != null ? ref.trim().toLowerCase() : void 0;
      if (encoding === 'gzip') {
        gunzip = zlib.createGunzip();
        return response.pipe(gunzip).pipe(outStream);
      } else {
        return response.pipe(outStream);
      }
    } else {
      throw new Error("Instagram returned status code: " + response.statusCode);
    }
  });
  return outStream;
};

module.exports = {
  jsonRequest: jsonRequest
};

// ---
// generated by coffee-script 1.9.2